'***************************************************************************'
'* Filename : BIN-HEX/DEC                                                  *'
'* Revision : 1.0                                                          *'
'* Controller : ATMEGA8                                                    *'
'* Compiler: BASCOM-AVR 2.0.8.1                                            *'
'* Author: Rubashka Vasiliy , LNR , 2024                                   *'
'***************************************************************************'

'$prog &HFF , &H04 , &HC1 , &H00                             ' 

$regfile = "m8def.dat"                                      ' 
$crystal = 8000000                                          '   
$framesize = 256                                            ' ,   
$hwstack = 256                                              '  
$swstack = 256                                              '  

'=== 
'  
Config Portc = Output
Config Portb = Output
' bin
Config Portd = Input
Portd = 255

'
Config Portb.0 = Input
Portb.0 = 1                                                 '   

'=== 
Config Timer0 = Timer , Prescale = 64 : On Timer0 Pulse     '  0,     
Enable Timer0                                               '   0

'===  
Enable Interrupts

'=== 
Dim Rejim As Byte                                           ' : 0-hex, 1-dec, 2-hex/dec
Dim Inp_bin As Byte                                         ' 
Dim Cifri(3) As Byte                                        '  
Dim Temp As Byte                                            ' 
Dim X As Byte                                               ' 
Dim Cif(3) As Byte                                          '

'==========     ==========
Readeeprom Rejim , 3
If Rejim > 1 Then Rejim = 0

Gosub Hex_dec
Waitms 1000


'=====  =====
Do
   ' 
   If Pinb.0 = 0 Then
      Incr Rejim
      If Rejim > 1 Then Rejim = 0

      Writeeeprom Rejim , 3                                 '   

      Gosub Hex_dec
      Waitms 500
   End If

   ' ,         
   Inp_bin.0 = Pind.7
   Inp_bin.1 = Pind.6
   Inp_bin.2 = Pind.5
   Inp_bin.3 = Pind.4
   Inp_bin.4 = Pind.3
   Inp_bin.5 = Pind.2
   Inp_bin.6 = Pind.1
   Inp_bin.7 = Pind.0

   '     
   Gosub Podgotovka

Loop
'=====  =====


'=====   =====
Podgotovka:
   If Rejim = 0 Then                                        '===HEX===
      Cifri(1) = 19                                         ' 
      Cifri(2) = 0
      Cifri(3) = 0

      Cifri(2).0 = Inp_bin.4
      Cifri(2).1 = Inp_bin.5
      Cifri(2).2 = Inp_bin.6
      Cifri(2).3 = Inp_bin.7

      Cifri(3).0 = Inp_bin.0
      Cifri(3).1 = Inp_bin.1
      Cifri(3).2 = Inp_bin.2
      Cifri(3).3 = Inp_bin.3
   End If

   If Rejim = 1 Then                                        '===DEC===

   ' 10
      If Inp_bin < 10 Then
         Cifri(1) = 0 : Cifri(2) = 0 : Cifri(3) = Inp_bin
      End If

   ' 10  99
      If Inp_bin > 9 And Inp_bin < 100 Then
         Cifri(1) = 0 : Cifri(2) = Inp_bin / 10 : Cifri(3) = Inp_bin Mod 10
      End If

   ' 
      If Inp_bin > 99 Then
         Temp = Inp_bin / 100
         Cifri(1) = Temp

         Temp = Temp * 100
         Temp = Inp_bin - Temp
         Cifri(2) = Temp / 10

         Cifri(3) = Temp Mod 10
      End If
   End If

   Cif(1) = Cifri(1)
   Cif(2) = Cifri(2)
   Cif(3) = Cifri(3)

Return

'=====   =====
Hex_dec:
   If Rejim = 0 Then                                     'HEX
      Cif(1) = 16
      Cif(2) = 14
      Cif(3) = 17
   End If
   If Rejim = 1 Then                                     'DEC
      Cif(1) = 13
      Cif(2) = 14
      Cif(3) = 12
   End If
Return

'=====  0 -  =====
Pulse:
   '  
   Portc.5 = 1
   Portb.3 = 1
   Portb.2 = 1

   '  
   Incr X : If X = 4 Then X = 1

   '      
   Temp = Lookup(cif(x) , Dta)

   '  
   '*          E30361-L-0-8-W ( )
   '*       ------------------------------------------------------------------
   '*
   '*        1p.  A   F  2p. 3p.  B
   '*
   '*         |   |   |   |   |   |
   '*       -------------------------
   '*      |   ===     ===     ===   |
   '*      |  |   |   |   |   |   |  |
   '*      |  |   |   |   |   |   |  |
   '*      |   ===     ===     ===   |
   '*      |  |   |   |   |   |   |  |
   '*      |  |   |   |   |   |   |  |
   '*      |   === o   === o   === o |
   '*       -------------------------
   '*         |   |   |   |   |
   '*
   '*         E   D   H   C   G

   Portc.4 = Temp.0                                         'A
   Portb.1 = Temp.1                                         'B
   Portb.4 = Temp.2                                         'C
   Portc.1 = Temp.3                                         'D
   Portc.2 = Temp.4                                         'E
   Portc.3 = Temp.5                                         'F
   Portb.5 = Temp.6                                         'G
   Portc.0 = 0                                              'H

   '  
   If X = 1 Then Portc.5 = 0
   If X = 2 Then Portb.3 = 0
   If X = 3 Then Portb.2 = 0

Return                                                      '  ,   

'=====    : 0123456789ABCDEFhH-  =====
'  
'
'   -- 1--
'  |      |
' 32      2
'  |      |
'   --64--
'  |      |
' 16      4
'  |      |
'   -- 8--
'          128

Dta:
   Data 63 , 6 , 91 , 79 , 102 , 109 , 125 , 7 , 127 , 111 , 119 , 124 , 57 , 94 , 121 , 113 , 116 , 118 , 64 , 0